Index: drivers/filesystems/btrfs/search.c
===================================================================
--- drivers/filesystems/btrfs/search.c	(révision 75772)
+++ drivers/filesystems/btrfs/search.c	(copie de travail)
@@ -232,451 +157,586 @@
         goto deref;
     }
 
-    Irp = IoBuildSynchronousFsdRequest(IRP_MJ_READ, DeviceObject, data, toread, &Offset, &Event, &IoStatusBlock);
-    
-    if (!Irp) {
-        ERR("IoBuildSynchronousFsdRequest failed\n");
-        goto deref;
-    }
+    Status = sync_read_phys(DeviceObject, superblock_addrs[0], toread, data, TRUE);
 
-    Status = IoCallDriver(DeviceObject, Irp);
+    if (NT_SUCCESS(Status) && ((superblock*)data)->magic == BTRFS_MAGIC) {
+        superblock* sb = (superblock*)data;
+        UINT32 crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
 
-    if (Status == STATUS_PENDING) {
-        KeWaitForSingleObject(&Event, Executive, KernelMode, FALSE, NULL);
-        Status = IoStatusBlock.Status;
-    }
+        if (crc32 != *((UINT32*)sb->checksum))
+            ERR("checksum error on superblock\n");
+        else {
+            TRACE("volume found\n");
 
-    if (NT_SUCCESS(Status) && IoStatusBlock.Information > 0 && ((superblock*)data)->magic == BTRFS_MAGIC) {
-        int i;
-        GET_LENGTH_INFORMATION gli;
-        superblock* sb = (superblock*)data;
-        volume* v = ExAllocatePoolWithTag(PagedPool, sizeof(volume), ALLOC_TAG);
-        
-        if (!v) {
-            ERR("out of memory\n");
-            goto deref;
-        }
-        
-        Status = dev_ioctl(DeviceObject, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0,
-                           &gli, sizeof(gli), TRUE, NULL);
-        if (!NT_SUCCESS(Status)) {
-            ERR("error reading length information: %08x\n", Status);
-            ExFreePool(v);
-            goto deref;
-        }
-        
-        if (part_num == 0) {
-            UNICODE_STRING us3;
-            
-            Status = create_part0(DriverObject, DeviceObject, devpath, &us3, &sb->dev_item.device_uuid);
-            
-            if (!NT_SUCCESS(Status)) {
-                ERR("create_part0 returned %08x\n", Status);
-                ExFreePool(v);
-                goto deref;
-            }
-            
-            v->devpath = us3;
-        } else {
-            v->devpath.Length = v->devpath.MaximumLength = devpath->Length;
-            v->devpath.Buffer = ExAllocatePoolWithTag(PagedPool, v->devpath.Length, ALLOC_TAG);
-            
-            if (!v->devpath.Buffer) {
-                ERR("out of memory\n");
-                ExFreePool(v);
-                goto deref;
-            }
-            
-            RtlCopyMemory(v->devpath.Buffer, devpath->Buffer, v->devpath.Length);
-        }
-        
-        RtlCopyMemory(&v->fsuuid, &sb->uuid, sizeof(BTRFS_UUID));
-        RtlCopyMemory(&v->devuuid, &sb->dev_item.device_uuid, sizeof(BTRFS_UUID));
-        v->devnum = sb->dev_item.dev_id;
-        v->processed = FALSE;
-        v->length = gli.Length.QuadPart;
-        v->gen1 = sb->generation;
-        v->gen2 = 0;
-        v->seeding = sb->flags & BTRFS_SUPERBLOCK_FLAGS_SEEDING ? TRUE : FALSE;
-        v->disk_num = disk_num;
-        v->part_num = part_num;
-        
-        ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
-        InsertTailList(volumes, &v->list_entry);
-        ExReleaseResourceLite(&volumes_lock);
-        
-        i = 1;
-        while (superblock_addrs[i] != 0 && superblock_addrs[i] + toread <= v->length) {
-            KeInitializeEvent(&Event, NotificationEvent, FALSE);
-            
-            Offset.QuadPart = superblock_addrs[i];
-            
-            Irp = IoBuildSynchronousFsdRequest(IRP_MJ_READ, DeviceObject, data, toread, &Offset, &Event, &IoStatusBlock);
-            
-            if (!Irp) {
-                ERR("IoBuildSynchronousFsdRequest failed\n");
-                goto deref;
-            }
+            if (length >= superblock_addrs[1] + toread) {
+                ULONG i = 1;
 
-            Status = IoCallDriver(DeviceObject, Irp);
+                superblock* sb2 = ExAllocatePoolWithTag(NonPagedPool, toread, ALLOC_TAG);
+                if (!sb2) {
+                    ERR("out of memory\n");
+                    goto deref;
+                }
 
-            if (Status == STATUS_PENDING) {
-                KeWaitForSingleObject(&Event, Executive, KernelMode, FALSE, NULL);
-                Status = IoStatusBlock.Status;
-            }
-            
-            if (NT_SUCCESS(Status)) {
-                UINT32 crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
-                
-                if (crc32 != *((UINT32*)sb->checksum))
-                    WARN("superblock %u CRC error\n", i);
-                else if (sb->generation > v->gen1) {
-                    v->gen2 = v->gen1;
-                    v->gen1 = sb->generation;
+                while (superblock_addrs[i] > 0 && length >= superblock_addrs[i] + toread) {
+                    Status = sync_read_phys(DeviceObject, superblock_addrs[i], toread, (PUCHAR)sb2, TRUE);
+
+                    if (NT_SUCCESS(Status) && sb2->magic == BTRFS_MAGIC) {
+                        crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb2->uuid, (ULONG)sizeof(superblock) - sizeof(sb2->checksum));
+
+                        if (crc32 == *((UINT32*)sb2->checksum) && sb2->generation > sb->generation)
+                            RtlCopyMemory(sb, sb2, toread);
+                    }
+
+                    i++;
                 }
-            } else {
-                ERR("got error %08x while reading superblock %u\n", Status, i);
+
+                ExFreePool(sb2);
             }
-            
-            i++;
+
+            if (!fs_ignored(&sb->uuid)) {
+                DeviceObject->Flags &= ~DO_VERIFY_VOLUME;
+                add_volume_device(sb, mountmgr, devpath, length, disk_num, part_num);
+            }
         }
-        
-        TRACE("volume found\n");
-        TRACE("gen1 = %llx, gen2 = %llx\n", v->gen1, v->gen2);
-        TRACE("FS uuid %02x%02x%02x%02x-%02x%02x-%02x%02x-%02x%02x-%02x%02x%02x%02x%02x%02x\n",
-              v->fsuuid.uuid[0], v->fsuuid.uuid[1], v->fsuuid.uuid[2], v->fsuuid.uuid[3], v->fsuuid.uuid[4], v->fsuuid.uuid[5], v->fsuuid.uuid[6], v->fsuuid.uuid[7],
-              v->fsuuid.uuid[8], v->fsuuid.uuid[9], v->fsuuid.uuid[10], v->fsuuid.uuid[11], v->fsuuid.uuid[12], v->fsuuid.uuid[13], v->fsuuid.uuid[14], v->fsuuid.uuid[15]);
-        TRACE("device uuid %02x%02x%02x%02x-%02x%02x-%02x%02x-%02x%02x-%02x%02x%02x%02x%02x%02x\n",
-              v->devuuid.uuid[0], v->devuuid.uuid[1], v->devuuid.uuid[2], v->devuuid.uuid[3], v->devuuid.uuid[4], v->devuuid.uuid[5], v->devuuid.uuid[6], v->devuuid.uuid[7],
-              v->devuuid.uuid[8], v->devuuid.uuid[9], v->devuuid.uuid[10], v->devuuid.uuid[11], v->devuuid.uuid[12], v->devuuid.uuid[13], v->devuuid.uuid[14], v->devuuid.uuid[15]);
-        TRACE("device number %llx\n", v->devnum);
     }
-    
+
 deref:
     if (data)
         ExFreePool(data);
-    
-    ObDereferenceObject(FileObject);
 }
 
-void remove_drive_letter(PDEVICE_OBJECT mountmgr, volume* v) {
+NTSTATUS remove_drive_letter(PDEVICE_OBJECT mountmgr, PUNICODE_STRING devpath) {
     NTSTATUS Status;
-    KEVENT Event;
-    PIRP Irp;
     MOUNTMGR_MOUNT_POINT* mmp;
     ULONG mmpsize;
     MOUNTMGR_MOUNT_POINTS mmps1, *mmps2;
-    IO_STATUS_BLOCK IoStatusBlock;
-    
-    mmpsize = sizeof(MOUNTMGR_MOUNT_POINT) + v->devpath.Length;
-    
+
+    TRACE("removing drive letter\n");
+
+    mmpsize = sizeof(MOUNTMGR_MOUNT_POINT) + devpath->Length;
+
     mmp = ExAllocatePoolWithTag(PagedPool, mmpsize, ALLOC_TAG);
     if (!mmp) {
         ERR("out of memory\n");
-        return;
+        return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     RtlZeroMemory(mmp, mmpsize);
-    
+
     mmp->DeviceNameOffset = sizeof(MOUNTMGR_MOUNT_POINT);
-    mmp->DeviceNameLength = v->devpath.Length;
-    RtlCopyMemory(&mmp[1], v->devpath.Buffer, v->devpath.Length);
-    
-    KeInitializeEvent(&Event, NotificationEvent, FALSE);
-    Irp = IoBuildDeviceIoControlRequest(IOCTL_MOUNTMGR_DELETE_POINTS,
-                                        mountmgr, mmp, mmpsize, 
-                                        &mmps1, sizeof(MOUNTMGR_MOUNT_POINTS), FALSE, &Event, &IoStatusBlock);
-    if (!Irp) {
-        ERR("%.*S: IoBuildDeviceIoControlRequest 1 failed\n", v->devpath.Length / sizeof(WCHAR), v->devpath.Buffer);
-        ExFreePool(mmp);
-        return;
-    }
+    mmp->DeviceNameLength = devpath->Length;
+    RtlCopyMemory(&mmp[1], devpath->Buffer, devpath->Length);
 
-    Status = IoCallDriver(mountmgr, Irp);
-    if (Status == STATUS_PENDING) {
-        KeWaitForSingleObject(&Event, Executive, KernelMode, FALSE, NULL);
-        Status = IoStatusBlock.Status;
-    }
+    Status = dev_ioctl(mountmgr, IOCTL_MOUNTMGR_DELETE_POINTS, mmp, mmpsize, &mmps1, sizeof(MOUNTMGR_MOUNT_POINTS), FALSE, NULL);
 
     if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW) {
-        ERR("%.*S: IoCallDriver 1  returned %08x\n", v->devpath.Length / sizeof(WCHAR), v->devpath.Buffer, Status);
+        ERR("IOCTL_MOUNTMGR_DELETE_POINTS 1 returned %08x\n", Status);
         ExFreePool(mmp);
-        return;
+        return Status;
     }
-    
+
     if (Status != STATUS_BUFFER_OVERFLOW || mmps1.Size == 0) {
         ExFreePool(mmp);
-        return;
+        return STATUS_NOT_FOUND;
     }
-    
+
     mmps2 = ExAllocatePoolWithTag(PagedPool, mmps1.Size, ALLOC_TAG);
     if (!mmps2) {
         ERR("out of memory\n");
         ExFreePool(mmp);
-        return;
+        return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
-    KeInitializeEvent(&Event, NotificationEvent, FALSE);
-    Irp = IoBuildDeviceIoControlRequest(IOCTL_MOUNTMGR_DELETE_POINTS,
-                                        mountmgr, mmp, mmpsize, 
-                                        mmps2, mmps1.Size, FALSE, &Event, &IoStatusBlock);
-    if (!Irp) {
-        ERR("%.*S: IoBuildDeviceIoControlRequest 2 failed\n", v->devpath.Length / sizeof(WCHAR), v->devpath.Buffer);
-        ExFreePool(mmps2);
-        ExFreePool(mmp);
-        return;
-    }
 
-    Status = IoCallDriver(mountmgr, Irp);
-    if (Status == STATUS_PENDING) {
-        KeWaitForSingleObject(&Event, Executive, KernelMode, FALSE, NULL);
-        Status = IoStatusBlock.Status;
-    }
+    Status = dev_ioctl(mountmgr, IOCTL_MOUNTMGR_DELETE_POINTS, mmp, mmpsize, mmps2, mmps1.Size, FALSE, NULL);
 
-    if (!NT_SUCCESS(Status)) {
-        ERR("%.*S: IoCallDriver 2 returned %08x\n", v->devpath.Length / sizeof(WCHAR), v->devpath.Buffer, Status);
-        ExFreePool(mmps2);
-        ExFreePool(mmp);
-        return;
-    }
-    
+    if (!NT_SUCCESS(Status))
+        ERR("IOCTL_MOUNTMGR_DELETE_POINTS 2 returned %08x\n", Status);
+
     ExFreePool(mmps2);
     ExFreePool(mmp);
-}
 
-static void refresh_mountmgr(PDEVICE_OBJECT mountmgr, LIST_ENTRY* volumes) {
-    LIST_ENTRY* le;
-    
-    ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
-    
-    le = volumes->Flink;
-    while (le != volumes) {
-        volume* v = CONTAINING_RECORD(le, volume, list_entry);
-        
-        if (!v->processed) {
-            LIST_ENTRY* le2 = le;
-            volume* mountvol = v;
-            
-            while (le2 != volumes) {
-                volume* v2 = CONTAINING_RECORD(le2, volume, list_entry);
-                
-                if (RtlCompareMemory(&v2->fsuuid, &v->fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
-                    v2->processed = TRUE;
-                    
-                    if (v2->devnum < mountvol->devnum) {
-                        remove_drive_letter(mountmgr, mountvol);
-                        mountvol = v2;
-                    } else if (v2->devnum > mountvol->devnum)
-                        remove_drive_letter(mountmgr, v2);
-                }
-                
-                le2 = le2->Flink;
-            }
-            
-            add_volume(mountmgr, &mountvol->devpath);
-        }
-        
-        le = le->Flink;
-    }
-    
-    ExReleaseResourceLite(&volumes_lock);
+    return Status;
 }
 
-static void add_pnp_disk(ULONG disk_num, PUNICODE_STRING devpath) {
-    LIST_ENTRY* le;
-    pnp_disk* disk;
-    
-    le = pnp_disks.Flink;
-    while (le != &pnp_disks) {
-        disk = CONTAINING_RECORD(le, pnp_disk, list_entry);
-        
-        if (disk->devpath.Length == devpath->Length &&
-            RtlCompareMemory(disk->devpath.Buffer, devpath->Buffer, devpath->Length) == devpath->Length)
-            return;
-        
-        le = le->Flink;
-    }
-    
-    disk = ExAllocatePoolWithTag(PagedPool, sizeof(pnp_disk), ALLOC_TAG);
-    if (!disk) {
-        ERR("out of memory\n");
-        return;
-    }
-    
-    disk->devpath.Length = disk->devpath.MaximumLength = devpath->Length;
-    disk->devpath.Buffer = ExAllocatePoolWithTag(PagedPool, devpath->Length, ALLOC_TAG);
-    
-    if (!disk->devpath.Buffer) {
-        ERR("out of memory\n");
-        ExFreePool(disk);
-        return;
-    }
-    
-    RtlCopyMemory(disk->devpath.Buffer, devpath->Buffer, devpath->Length);
-    
-    disk->disk_num = disk_num;
-    
-    InsertTailList(&pnp_disks, &disk->list_entry);
-}
-
-static void disk_arrival(PDRIVER_OBJECT DriverObject, PUNICODE_STRING devpath) {
-    PFILE_OBJECT FileObject, FileObject2;
+void disk_arrival(PDRIVER_OBJECT DriverObject, PUNICODE_STRING devpath) {
+    PFILE_OBJECT FileObject, mountmgrfo;
     PDEVICE_OBJECT devobj, mountmgr;
     NTSTATUS Status;
     STORAGE_DEVICE_NUMBER sdn;
     ULONG dlisize;
-    DRIVE_LAYOUT_INFORMATION_EX* dli;
+    DRIVE_LAYOUT_INFORMATION_EX* dli = NULL;
     IO_STATUS_BLOCK iosb;
-    int i, num_parts = 0;
-    UNICODE_STRING devname, num, bspus, mmdevpath;
-    WCHAR devnamew[255], numw[20];
-    USHORT preflen;
-    
-    static WCHAR device_harddisk[] = L"\\Device\\Harddisk";
-    static WCHAR bs_partition[] = L"\\Partition";
-    
-    // FIXME - work with CD-ROMs and floppies(?)
-        
+    GET_LENGTH_INFORMATION gli;
+    UNICODE_STRING mmdevpath;
+
+    UNUSED(DriverObject);
+
     Status = IoGetDeviceObjectPointer(devpath, FILE_READ_ATTRIBUTES, &FileObject, &devobj);
     if (!NT_SUCCESS(Status)) {
         ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
         return;
     }
-    
+
     RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
-    Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &FileObject2, &mountmgr);
+    Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &mountmgrfo, &mountmgr);
     if (!NT_SUCCESS(Status)) {
         ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
         ObDereferenceObject(FileObject);
         return;
     }
-    
-    Status = dev_ioctl(devobj, IOCTL_STORAGE_GET_DEVICE_NUMBER, NULL, 0,
-                       &sdn, sizeof(STORAGE_DEVICE_NUMBER), TRUE, &iosb);
-    if (!NT_SUCCESS(Status)) {
-        ERR("IOCTL_STORAGE_GET_DEVICE_NUMBER returned %08x\n", Status);
-        goto end;
-    }
-    
-    ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
-    add_pnp_disk(sdn.DeviceNumber, devpath);
-    ExReleaseResourceLite(&volumes_lock);
-    
+
     dlisize = 0;
-    
+
     do {
         dlisize += 1024;
+
+        if (dli)
+            ExFreePool(dli);
+
         dli = ExAllocatePoolWithTag(PagedPool, dlisize, ALLOC_TAG);
-    
+        if (!dli) {
+            ERR("out of memory\n");
+            goto end;
+        }
+
         Status = dev_ioctl(devobj, IOCTL_DISK_GET_DRIVE_LAYOUT_EX, NULL, 0,
                            dli, dlisize, TRUE, &iosb);
     } while (Status == STATUS_BUFFER_TOO_SMALL);
-    
-    if (!NT_SUCCESS(Status)) {
+
+    // only consider disk as a potential filesystem if it has no partitions
+    if (NT_SUCCESS(Status) && dli->PartitionCount > 0) {
         ExFreePool(dli);
-        goto no_parts;
+        goto end;
     }
-    
-    wcscpy(devnamew, device_harddisk);
-    devname.Buffer = devnamew;
-    devname.MaximumLength = sizeof(devnamew);
-    devname.Length = wcslen(device_harddisk) * sizeof(WCHAR);
 
-    num.Buffer = numw;
-    num.MaximumLength = sizeof(numw);
-    RtlIntegerToUnicodeString(sdn.DeviceNumber, 10, &num);
-    RtlAppendUnicodeStringToString(&devname, &num);
-    
-    bspus.Buffer = bs_partition;
-    bspus.Length = bspus.MaximumLength = wcslen(bs_partition) * sizeof(WCHAR);
-    RtlAppendUnicodeStringToString(&devname, &bspus);
-    
-    preflen = devname.Length;
-    
-    for (i = 0; i < dli->PartitionCount; i++) {
-        if (dli->PartitionEntry[i].PartitionLength.QuadPart != 0 && dli->PartitionEntry[i].PartitionNumber != 0) {
-            devname.Length = preflen;
-            RtlIntegerToUnicodeString(dli->PartitionEntry[i].PartitionNumber, 10, &num);
-            RtlAppendUnicodeStringToString(&devname, &num);
-            
-            test_vol(DriverObject, mountmgr, &devname, sdn.DeviceNumber, dli->PartitionEntry[i].PartitionNumber, &volumes);
-            
-            num_parts++;
+    ExFreePool(dli);
+
+    Status = dev_ioctl(devobj, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0,
+                        &gli, sizeof(gli), TRUE, NULL);
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("error reading length information: %08x\n", Status);
+        goto end;
+    }
+
+    Status = dev_ioctl(devobj, IOCTL_STORAGE_GET_DEVICE_NUMBER, NULL, 0,
+                       &sdn, sizeof(STORAGE_DEVICE_NUMBER), TRUE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        TRACE("IOCTL_STORAGE_GET_DEVICE_NUMBER returned %08x\n", Status);
+        sdn.DeviceNumber = 0xffffffff;
+        sdn.PartitionNumber = 0;
+    } else
+        TRACE("DeviceType = %u, DeviceNumber = %u, PartitionNumber = %u\n", sdn.DeviceType, sdn.DeviceNumber, sdn.PartitionNumber);
+
+    test_vol(mountmgr, devobj, devpath, sdn.DeviceNumber, sdn.PartitionNumber, gli.Length.QuadPart);
+
+end:
+    ObDereferenceObject(FileObject);
+    ObDereferenceObject(mountmgrfo);
+}
+
+void remove_volume_child(_Inout_ _Requires_exclusive_lock_held_(_Curr_->child_lock) _Releases_exclusive_lock_(_Curr_->child_lock) _In_ volume_device_extension* vde,
+                         _In_ volume_child* vc, _In_ BOOL skip_dev) {
+    NTSTATUS Status;
+    pdo_device_extension* pdode = vde->pdode;
+    device_extension* Vcb = vde->mounted_device ? vde->mounted_device->DeviceExtension : NULL;
+
+    if (vc->notification_entry)
+#ifdef __REACTOS__
+        IoUnregisterPlugPlayNotification(vc->notification_entry);
+#else
+        IoUnregisterPlugPlayNotificationEx(vc->notification_entry);
+#endif
+
+    if (vde->mounted_device && (!Vcb || !Vcb->options.allow_degraded)) {
+        Status = pnp_surprise_removal(vde->mounted_device, NULL);
+        if (!NT_SUCCESS(Status))
+            ERR("pnp_surprise_removal returned %08x\n", Status);
+    }
+
+    if (!Vcb || !Vcb->options.allow_degraded) {
+        Status = IoSetDeviceInterfaceState(&vde->bus_name, FALSE);
+        if (!NT_SUCCESS(Status))
+            WARN("IoSetDeviceInterfaceState returned %08x\n", Status);
+    }
+
+    if (pdode->children_loaded > 0) {
+        UNICODE_STRING mmdevpath;
+        PFILE_OBJECT FileObject;
+        PDEVICE_OBJECT mountmgr;
+        LIST_ENTRY* le;
+
+        if (!Vcb || !Vcb->options.allow_degraded) {
+            RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
+            Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &FileObject, &mountmgr);
+            if (!NT_SUCCESS(Status))
+                ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
+            else {
+                le = pdode->children.Flink;
+
+                while (le != &pdode->children) {
+                    volume_child* vc2 = CONTAINING_RECORD(le, volume_child, list_entry);
+
+                    if (vc2->had_drive_letter) { // re-add entry to mountmgr
+                        MOUNTDEV_NAME mdn;
+
+                        Status = dev_ioctl(vc2->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, &mdn, sizeof(MOUNTDEV_NAME), TRUE, NULL);
+                        if (!NT_SUCCESS(Status) && Status != STATUS_BUFFER_OVERFLOW)
+                            ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+                        else {
+                            MOUNTDEV_NAME* mdn2;
+                            ULONG mdnsize = (ULONG)offsetof(MOUNTDEV_NAME, Name[0]) + mdn.NameLength;
+
+                            mdn2 = ExAllocatePoolWithTag(PagedPool, mdnsize, ALLOC_TAG);
+                            if (!mdn2)
+                                ERR("out of memory\n");
+                            else {
+                                Status = dev_ioctl(vc2->devobj, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0, mdn2, mdnsize, TRUE, NULL);
+                                if (!NT_SUCCESS(Status))
+                                    ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+                                else {
+                                    UNICODE_STRING name;
+
+                                    name.Buffer = mdn2->Name;
+                                    name.Length = name.MaximumLength = mdn2->NameLength;
+
+                                    Status = mountmgr_add_drive_letter(mountmgr, &name);
+                                    if (!NT_SUCCESS(Status))
+                                        WARN("mountmgr_add_drive_letter returned %08x\n", Status);
+                                }
+
+                                ExFreePool(mdn2);
+                            }
+                        }
+                    }
+
+                    le = le->Flink;
+                }
+
+                ObDereferenceObject(FileObject);
+            }
+        } else if (!skip_dev) {
+            ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
+
+            le = Vcb->devices.Flink;
+            while (le != &Vcb->devices) {
+                device* dev = CONTAINING_RECORD(le, device, list_entry);
+
+                if (dev->devobj == vc->devobj) {
+                    dev->devobj = NULL; // mark as missing
+                    break;
+                }
+
+                le = le->Flink;
+            }
+
+            ExReleaseResourceLite(&Vcb->tree_lock);
         }
+
+        if (vde->device->Characteristics & FILE_REMOVABLE_MEDIA) {
+            vde->device->Characteristics &= ~FILE_REMOVABLE_MEDIA;
+
+            le = pdode->children.Flink;
+            while (le != &pdode->children) {
+                volume_child* vc2 = CONTAINING_RECORD(le, volume_child, list_entry);
+
+                if (vc2 != vc && vc2->devobj->Characteristics & FILE_REMOVABLE_MEDIA) {
+                    vde->device->Characteristics |= FILE_REMOVABLE_MEDIA;
+                    break;
+                }
+
+                le = le->Flink;
+            }
+        }
     }
-    
-    ExFreePool(dli);
-    
-no_parts:
-    if (num_parts == 0) {
-        devname.Length = preflen;
-        devname.Buffer[devname.Length / sizeof(WCHAR)] = '0';
-        devname.Length += sizeof(WCHAR);
-        
-        test_vol(DriverObject, mountmgr, &devname, sdn.DeviceNumber, 0, &volumes);
+
+    ObDereferenceObject(vc->fileobj);
+    ExFreePool(vc->pnp_name.Buffer);
+    RemoveEntryList(&vc->list_entry);
+    ExFreePool(vc);
+
+    pdode->children_loaded--;
+
+    if (pdode->children_loaded == 0) { // remove volume device
+        BOOL remove = FALSE;
+
+        RemoveEntryList(&pdode->list_entry);
+
+        vde->removing = TRUE;
+
+        Status = IoSetDeviceInterfaceState(&vde->bus_name, FALSE);
+        if (!NT_SUCCESS(Status))
+            WARN("IoSetDeviceInterfaceState returned %08x\n", Status);
+
+        if (vde->pdo->AttachedDevice)
+            IoDetachDevice(vde->pdo);
+
+        if (vde->open_count == 0)
+            remove = TRUE;
+
+        ExReleaseResourceLite(&pdode->child_lock);
+
+        if (!no_pnp) {
+            control_device_extension* cde = master_devobj->DeviceExtension;
+
+            IoInvalidateDeviceRelations(cde->buspdo, BusRelations);
+        }
+
+        if (remove) {
+            PDEVICE_OBJECT pdo;
+
+            if (vde->name.Buffer)
+                ExFreePool(vde->name.Buffer);
+
+            if (Vcb)
+                Vcb->vde = NULL;
+
+            ExDeleteResourceLite(&pdode->child_lock);
+
+            pdo = vde->pdo;
+            IoDeleteDevice(vde->device);
+
+            if (no_pnp)
+                IoDeleteDevice(pdo);
+        }
+    } else
+        ExReleaseResourceLite(&pdode->child_lock);
+}
+
+void volume_arrival(PDRIVER_OBJECT DriverObject, PUNICODE_STRING devpath) {
+    STORAGE_DEVICE_NUMBER sdn;
+    PFILE_OBJECT FileObject, mountmgrfo;
+    UNICODE_STRING mmdevpath;
+    PDEVICE_OBJECT devobj, mountmgr;
+    GET_LENGTH_INFORMATION gli;
+    NTSTATUS Status;
+
+    TRACE("%.*S\n", devpath->Length / sizeof(WCHAR), devpath->Buffer);
+
+    Status = IoGetDeviceObjectPointer(devpath, FILE_READ_ATTRIBUTES, &FileObject, &devobj);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
+        return;
     }
-    
+
+    // make sure we're not processing devices we've created ourselves
+
+    if (devobj->DriverObject == DriverObject)
+        goto end;
+
+    Status = dev_ioctl(devobj, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0, &gli, sizeof(gli), TRUE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IOCTL_DISK_GET_LENGTH_INFO returned %08x\n", Status);
+        goto end;
+    }
+
+    Status = dev_ioctl(devobj, IOCTL_STORAGE_GET_DEVICE_NUMBER, NULL, 0,
+                       &sdn, sizeof(STORAGE_DEVICE_NUMBER), TRUE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        TRACE("IOCTL_STORAGE_GET_DEVICE_NUMBER returned %08x\n", Status);
+        sdn.DeviceNumber = 0xffffffff;
+        sdn.PartitionNumber = 0;
+    } else
+        TRACE("DeviceType = %u, DeviceNumber = %u, PartitionNumber = %u\n", sdn.DeviceType, sdn.DeviceNumber, sdn.PartitionNumber);
+
+    // If we've just added a partition to a whole-disk filesystem, unmount it
+    if (sdn.DeviceNumber != 0xffffffff) {
+        LIST_ENTRY* le;
+
+        ExAcquireResourceExclusiveLite(&pdo_list_lock, TRUE);
+
+        le = pdo_list.Flink;
+        while (le != &pdo_list) {
+            pdo_device_extension* pdode = CONTAINING_RECORD(le, pdo_device_extension, list_entry);
+            LIST_ENTRY* le2;
+            BOOL changed = FALSE;
+
+            if (pdode->vde) {
+                ExAcquireResourceExclusiveLite(&pdode->child_lock, TRUE);
+
+                le2 = pdode->children.Flink;
+                while (le2 != &pdode->children) {
+                    volume_child* vc = CONTAINING_RECORD(le2, volume_child, list_entry);
+                    LIST_ENTRY* le3 = le2->Flink;
+
+                    if (vc->disk_num == sdn.DeviceNumber && vc->part_num == 0) {
+                        TRACE("removing device\n");
+
+                        remove_volume_child(pdode->vde, vc, FALSE);
+                        changed = TRUE;
+
+                        break;
+                    }
+
+                    le2 = le3;
+                }
+
+                if (!changed)
+                    ExReleaseResourceLite(&pdode->child_lock);
+                else
+                    break;
+            }
+
+            le = le->Flink;
+        }
+
+        ExReleaseResourceLite(&pdo_list_lock);
+    }
+
+    RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
+    Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &mountmgrfo, &mountmgr);
+    if (!NT_SUCCESS(Status)) {
+        ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
+        goto end;
+    }
+
+    test_vol(mountmgr, devobj, devpath, sdn.DeviceNumber, sdn.PartitionNumber, gli.Length.QuadPart);
+
+    ObDereferenceObject(mountmgrfo);
+
 end:
-    refresh_mountmgr(mountmgr, &volumes);
-
     ObDereferenceObject(FileObject);
-    ObDereferenceObject(FileObject2);
 }
 
-static void disk_removal(PDRIVER_OBJECT DriverObject, PUNICODE_STRING devpath) {
+void volume_removal(PDRIVER_OBJECT DriverObject, PUNICODE_STRING devpath) {
     LIST_ENTRY* le;
-    pnp_disk* disk = NULL;
-    
-    // FIXME - remove Partition0Btrfs devices and unlink from mountmgr
-    // FIXME - emergency unmount of RAIDed volumes
-    
-    ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
-    
-    le = pnp_disks.Flink;
-    while (le != &pnp_disks) {
-        pnp_disk* disk2 = CONTAINING_RECORD(le, pnp_disk, list_entry);
-        
-        if (disk2->devpath.Length == devpath->Length &&
-            RtlCompareMemory(disk2->devpath.Buffer, devpath->Buffer, devpath->Length) == devpath->Length) {
-            disk = disk2;
-            break;
+    UNICODE_STRING devpath2;
+
+    TRACE("%.*S\n", devpath->Length / sizeof(WCHAR), devpath->Buffer);
+
+    UNUSED(DriverObject);
+
+    devpath2 = *devpath;
+
+    if (devpath->Length > 4 * sizeof(WCHAR) && devpath->Buffer[0] == '\\' && (devpath->Buffer[1] == '\\' || devpath->Buffer[1] == '?') &&
+        devpath->Buffer[2] == '?' && devpath->Buffer[3] == '\\') {
+        devpath2.Buffer = &devpath2.Buffer[3];
+        devpath2.Length -= 3 * sizeof(WCHAR);
+        devpath2.MaximumLength -= 3 * sizeof(WCHAR);
+    }
+
+    ExAcquireResourceExclusiveLite(&pdo_list_lock, TRUE);
+
+    le = pdo_list.Flink;
+    while (le != &pdo_list) {
+        pdo_device_extension* pdode = CONTAINING_RECORD(le, pdo_device_extension, list_entry);
+        LIST_ENTRY* le2;
+        BOOL changed = FALSE;
+
+        if (pdode->vde) {
+            ExAcquireResourceExclusiveLite(&pdode->child_lock, TRUE);
+
+            le2 = pdode->children.Flink;
+            while (le2 != &pdode->children) {
+                volume_child* vc = CONTAINING_RECORD(le2, volume_child, list_entry);
+                LIST_ENTRY* le3 = le2->Flink;
+
+                if (vc->pnp_name.Length == devpath2.Length && RtlCompareMemory(vc->pnp_name.Buffer, devpath2.Buffer, devpath2.Length) == devpath2.Length) {
+                    TRACE("removing device\n");
+
+                    remove_volume_child(pdode->vde, vc, FALSE);
+                    changed = TRUE;
+
+                    break;
+                }
+
+                le2 = le3;
+            }
+
+            if (!changed)
+                ExReleaseResourceLite(&pdode->child_lock);
+            else
+                break;
         }
-        
+
         le = le->Flink;
     }
-    
-    if (!disk) {
-        ExReleaseResourceLite(&volumes_lock);
+
+    ExReleaseResourceLite(&pdo_list_lock);
+}
+
+typedef struct {
+    PDRIVER_OBJECT DriverObject;
+    UNICODE_STRING name;
+    pnp_callback func;
+    PIO_WORKITEM work_item;
+} pnp_callback_context;
+
+_Function_class_(IO_WORKITEM_ROUTINE)
+#ifdef __REACTOS__
+static void NTAPI do_pnp_callback(PDEVICE_OBJECT DeviceObject, PVOID con) {
+#else
+static void do_pnp_callback(PDEVICE_OBJECT DeviceObject, PVOID con) {
+#endif
+    pnp_callback_context* context = con;
+
+    UNUSED(DeviceObject);
+
+    context->func(context->DriverObject, &context->name);
+
+    if (context->name.Buffer)
+        ExFreePool(context->name.Buffer);
+
+    IoFreeWorkItem(context->work_item);
+}
+
+static void enqueue_pnp_callback(PDRIVER_OBJECT DriverObject, PUNICODE_STRING name, pnp_callback func) {
+    PIO_WORKITEM work_item;
+    pnp_callback_context* context;
+
+    work_item = IoAllocateWorkItem(master_devobj);
+
+    context = ExAllocatePoolWithTag(PagedPool, sizeof(pnp_callback_context), ALLOC_TAG);
+
+    if (!context) {
+        ERR("out of memory\n");
+        IoFreeWorkItem(work_item);
         return;
     }
 
-    le = volumes.Flink;
-    while (le != &volumes) {
-        volume* v = CONTAINING_RECORD(le, volume, list_entry);
-        LIST_ENTRY* le2 = le->Flink;
-        
-        if (v->disk_num == disk->disk_num) {
-            if (v->devpath.Buffer)
-                ExFreePool(v->devpath.Buffer);
-            
-            RemoveEntryList(&v->list_entry);
-            
-            ExFreePool(v);
+    context->DriverObject = DriverObject;
+
+    if (name->Length > 0) {
+        context->name.Buffer = ExAllocatePoolWithTag(PagedPool, name->Length, ALLOC_TAG);
+        if (!context->name.Buffer) {
+            ERR("out of memory\n");
+            ExFreePool(context);
+            IoFreeWorkItem(work_item);
+            return;
         }
-        
-        le = le2;
+
+        RtlCopyMemory(context->name.Buffer, name->Buffer, name->Length);
+        context->name.Length = context->name.MaximumLength = name->Length;
+    } else {
+        context->name.Length = context->name.MaximumLength = 0;
+        context->name.Buffer = NULL;
     }
-    
-    ExReleaseResourceLite(&volumes_lock);
-    
-    ExFreePool(disk->devpath.Buffer);
-    
-    RemoveEntryList(&disk->list_entry);
-    
-    ExFreePool(disk);
+
+    context->func = func;
+    context->work_item = work_item;
+
+    IoQueueWorkItem(work_item, do_pnp_callback, DelayedWorkQueue, context);
 }
 
+_Function_class_(DRIVER_NOTIFICATION_CALLBACK_ROUTINE)
 #ifdef __REACTOS__
+NTSTATUS NTAPI volume_notification(PVOID NotificationStructure, PVOID Context) {
+#else
+NTSTATUS volume_notification(PVOID NotificationStructure, PVOID Context) {
+#endif
+    DEVICE_INTERFACE_CHANGE_NOTIFICATION* dicn = (DEVICE_INTERFACE_CHANGE_NOTIFICATION*)NotificationStructure;
+    PDRIVER_OBJECT DriverObject = (PDRIVER_OBJECT)Context;
+
+    if (RtlCompareMemory(&dicn->Event, &GUID_DEVICE_INTERFACE_ARRIVAL, sizeof(GUID)) == sizeof(GUID))
+        enqueue_pnp_callback(DriverObject, dicn->SymbolicLinkName, volume_arrival);
+    else if (RtlCompareMemory(&dicn->Event, &GUID_DEVICE_INTERFACE_REMOVAL, sizeof(GUID)) == sizeof(GUID))
+        enqueue_pnp_callback(DriverObject, dicn->SymbolicLinkName, volume_removal);
+
+    return STATUS_SUCCESS;
+}
+
+_Function_class_(DRIVER_NOTIFICATION_CALLBACK_ROUTINE)
+#ifdef __REACTOS__
 NTSTATUS NTAPI pnp_notification(PVOID NotificationStructure, PVOID Context) {
 #else
 NTSTATUS pnp_notification(PVOID NotificationStructure, PVOID Context) {
